#include <mpi.h>

void main(int argc, char **argv)
{
	int size, rank;

	MPI_Init(&argc,&argv);
	MPI_Comm_size(MPI_COMM_WORLD,&size);
	MPI_Comm_rank(MPI_COMM_WORLD,&rank);

	if (rank%2==0)
	{
		int send=rank;
		printf("Io sono il processo PARI numero %d di %d.",rank,size);
		MPI_Send(&send,1,MPI_INT,rank+1,0,MPI_COMM_WORLD);
		printf("Io sono il processo PARI numero %d e ho inviato %d a %d.",rank,send,rank+1);
	}

	else
	{
		int receive;
		printf("Io sono il processo DISPARI numero %d di %d.",rank,size);
		MPI_Recv(&receive,1,MPI_INT,rank-1,0,MPI_COMM_WORLD,MPI_STATUS_IGNORE);
		printf("Io sono il processo DISPARI numero %d e ho ricevuto %d da %d.",rank,receive,rank-1);
	}
	MPI_Finalize();
}